package com.capgemini.reports.snecmaobjects.part;

import com.capgemini.framework.teamcenter.authent.TcSession;
import com.capgemini.reports.snecmaobjects.visitor.IComponentVisitor;
import com.capgemini.reports.snecmaobjects.visitor.IReceptorVisitor;
import com.teamcenter.soa.client.model.strong.ItemRevision;

import static com.capgemini.framework.teamcenter.object.SnecmaObjectProperties.*;
import static com.capgemini.framework.teamcenter.object.types.SnecmaObjectTypes.ALTERNATE_REVISION;

/**
 * Class representing a AlternateRevision.
 */
public class AlternateRevision extends AbstractAltOrDetRevision {
    private static final long serialVersionUID = 6488368187302297526L;

    public AlternateRevision(final TcSession session, final ItemRevision itemRevision) {
        super(session, itemRevision);
    }

    public String getTypeAlt1() {
        return getMasterFormRev().getPropertyObject(PV_TYPE_ALTERNATIVE_1).getStringValue();
    }

    public String getTypeAlt2() {
        return getMasterFormRev().getPropertyObject(PV_TYPE_ALTERNATIVE_2).getStringValue();
    }

    public String getObturation() {
        return getMasterFormRev().getPropertyObject(PV_OBTURATION).getStringValue();
    }

    @Override
    public <T> T accept(final IReceptorVisitor<T> aReceptorVisitor) {
        return aReceptorVisitor.visitReceptor(this);
    }

    @Override
    public <T> T accept(final IComponentVisitor<T> aComponentVisitor) {
        return aComponentVisitor.visitComponent(this);
    }

    @Override
    public boolean isSuperModel() {
        return false;
    }

    @Override
    public String toString() {
        return ALTERNATE_REVISION + " " + this.getItemId();
    }
}
